/*
 * This file is part of SOCKMAND.
 * 
 * SOCKMAND is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * SOCKMAND is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with SOCKMAND.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */


#include<stdio.h>
#include<sys/socket.h>
#include<netinet/in.h>
#include<stdlib.h>
#include<unistd.h>
#include<string.h>
#include<netdb.h>
#include<arpa/inet.h>
#include<sys/types.h>
#include<time.h>
#include <sys/sendfile.h>
#include <fcntl.h>


long int getmillis(){
    struct timeval now;
    gettimeofday( &now, 0 );
    return (now.tv_usec + 1000000 * now.tv_sec)/1000;
}

int main (int argc,char **argv)
{
    
     if(argc != 2){
        printf("use port as arg\n");
        return -1;
     }
    int listenfd,connfd;
    
    struct sockaddr_in serv;
    int port = atoi(argv[1]);
    
    
    listenfd = socket(AF_INET,SOCK_STREAM,0);
    bzero(&serv,sizeof(serv));
    serv.sin_family = AF_INET;
    serv.sin_addr.s_addr = htonl(INADDR_ANY);
    serv.sin_port = htons(port);
    bind(listenfd,(struct sockaddr*)&serv,sizeof(serv));
    listen(listenfd,5);
    connfd = accept(listenfd,(struct sockaddr*)NULL,NULL);
    long int start = getmillis();
    
    int bytesize = 0;
    read(connfd, &bytesize, sizeof(int));
    
    int readremaining = bytesize;
    
    fprintf(stderr,"Downloading file with size %d\n", bytesize);    

    
    char *buf = malloc(bytesize);
    char *b = buf;

    //Download file
    while(readremaining > 0){
        int r = read(connfd, b, readremaining);
        readremaining -= r;
        b+=r;
    }
    long int end = getmillis();
    long int ms = end - start;
   // double s = ms/1000.0;
    double mbytesps = (double)bytesize/(double)1000/(double)ms;
    
    
    int fd = open( "output",O_RDWR | O_CREAT, 0666);
    printf("Filetransfer took %ldms\n", ms);
    printf("File transferred in %f Mbps\n", mbytesps*8);
    
    int writeremaining = bytesize;
    //Write file
    printf("Writing file\n");
    char *b2 = buf;
    while(writeremaining > 0){
        int w =  write(fd, b2, writeremaining);
        writeremaining -= w;
        b2+=w;
        printf("Writeremaining %d\n", writeremaining);
    }
    
    close(fd);
    close(connfd);
    free(buf);
    return 0;
}



