/*
 * This file is part of SOCKMAND.
 * 
 * SOCKMAND is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * SOCKMAND is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with SOCKMAND.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */


#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>

#define BUFLEN 1400
#include "libsockmand.h"

int main(int argc, char **argv)
{
    struct timeval start, end;
    long elapsed_utime;    /* elapsed time in microseconds */
    long elapsed_seconds;  /* diff between seconds counter */
    long elapsed_useconds; /* diff between microseconds counter */
    
    if(argc<4){
        fprintf(stderr, "Usage: %s <destination IP address> <destport> <count>\n", argv[0]);
        exit(EXIT_FAILURE);
    }
    unsigned int dst = inet_addr(argv[1]);
    short port = htons(atoi(argv[2]));
    int count = atoi(argv[3]);
    char buf[BUFLEN] = "Ping message\0";
    int sd = sm_socket(AF_INET,SOCK_DGRAM,0,0);    
    
    int i;
    long sum = 0;
    
    struct sockaddr_in servaddr;  
    bzero(&servaddr,sizeof(servaddr));
    servaddr.sin_family = AF_INET;
    servaddr.sin_addr.s_addr = dst;
    servaddr.sin_port = port;
    socklen_t slen = sizeof(servaddr);
    
    
    struct sockaddr_in s;   
    socklen_t s2 =  sizeof(s);
    
    sm_sendto(sd, buf, BUFLEN, 0, (struct sockaddr *)&servaddr,slen); //virtual bind
    sm_recvfrom(sd, buf, BUFLEN, 0, (struct sockaddr *)&s,&s2);
    
    sleep(1);
    for(i=0; i < count; i++){
        
        gettimeofday(&start, NULL);
        sm_sendto(sd, buf, BUFLEN, 0, (struct sockaddr *)&servaddr,slen);
        sm_recvfrom(sd, buf, BUFLEN, 0, (struct sockaddr *)&s,&s2);
        gettimeofday(&end, NULL);
        
        
        elapsed_seconds  = end.tv_sec  - start.tv_sec;
        elapsed_useconds = end.tv_usec - start.tv_usec;
        elapsed_utime = (elapsed_seconds) * 1000000 + elapsed_useconds;
        
        printf("%ld\n", elapsed_utime);
        sum += elapsed_utime;
        sleep(1);
    }
    printf("\nDone doing tests\n");
    double average = (double)sum/(double)count;
    printf("Average RTT: %f microseconds\n",average);
    close(sd);
    return 0;
}