/*
 * This file is part of SOCKMAND.
 * 
 * SOCKMAND is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * SOCKMAND is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with SOCKMAND.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */


#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include <sys/types.h>
#include <sys/socket.h>

#define BUFLEN  1400

int main(int argc, char **argv)
{
    struct sockaddr_in   si_local, si_remote;
    int port;
    socklen_t slen;
    char buf[BUFLEN];
    slen     =   sizeof(si_remote);
    
    if(argc!=2){
        fprintf(stderr, "Usage: %s <port number>\n", argv[0]);
        return 0;
    }
    
    port=atoi(argv[1]);
    if(port<0){
        fprintf(stderr, "Could not parse port\n", argv[0]);
        return 0;
    }
    
    int s=socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);
    
    memset((char *) &si_local, 0, sizeof(si_local));
    si_local.sin_family       =  AF_INET;
    si_local.sin_port         =  htons(port);
    si_local.sin_addr.s_addr  =  htonl(INADDR_ANY);
    if (bind(s, (const struct sockaddr *)&si_local, sizeof(si_local))==-1){
        perror("bind");
        exit(EXIT_FAILURE);
    }
    
    while(1==1){
        int read = recvfrom(s, buf, BUFLEN, 0, (struct sockaddr *)&si_remote, &slen);           
        sendto(s, buf, read, 0, (struct sockaddr *)&si_remote, slen);
    }
    close(s);
    return 0;
}
