/*
 * This file is part of SOCKMAND.
 * 
 * SOCKMAND is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * SOCKMAND is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with SOCKMAND.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */


#include <stdio.h>
#include <stdlib.h>
#include <netinet/in.h>
#include <string.h>

#include "libsockmand.h"

int main(int argc, char **argv){
    struct sockaddr_in   si_local;
    int sd;
    char buf[1500];
    
    if(argc!=2){
        fprintf(stderr, "Usage: %s <port number>\n", argv[0]);
        return 0;
    }
    
    int port=atoi(argv[1]);
    if(port==-1){
        fprintf(stderr, "Usage: %s <port number>\n", argv[0]);
        return 0;
    }
    
    
    if ((sd = sm_socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP, 0))==-1){
        printf("Error in sm_socket()");
        return 0;
    }
    
    memset((char *) &si_local, 0, sizeof(si_local));
    si_local.sin_family       =  AF_INET;
    si_local.sin_port         =  htons(port);
    si_local.sin_addr.s_addr  =  htonl(INADDR_ANY);
    if (sm_bind(sd, (const struct sockaddr *)&si_local, sizeof(si_local)) == -1){
        printf("Error in sm_bind()");
        return 0;
    }
    
    while(1){
        if (sm_recvfrom(sd, buf, 1500, 0, 0, 0)==-1){
            printf("Error in sm_recvfrom()");
            return 0;
        }
    }
    return 0;
}
