/*
 * This file is part of SOCKMAND.
 * 
 * SOCKMAND is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * SOCKMAND is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with SOCKMAND.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */

#define SOCK_PATH "/tmp/sockmand"

#define SOCKET 1
#define BIND 2
#define CONNECT 3
#define SENDTO 4
#define REBUILD 5
#define WRITE 6
#define LISTENMSG 7

#define MAXWRITESIZE 5000

struct msg{
    char msgtype;
};

struct socketmsg{
    char msgtype;
    int protocol;
    int mcappolicy;
    short pad; //PADDING
};

struct listenmsg{
    char msgtype;
    int pad1;
    int pad2;
    short pad3;
};

struct rebuildmsg{
    char msgtype;
    int uuid;
    int pad;
    short pad2;
};


struct bindmsg{
    char msgtype;
    int pad1;
    int pad2;
    short port;
};

struct connectmsg{
    char msgtype;
    unsigned int dest_addr;    
    short port;
    int pad;
};

struct sendtomsg{
    char msgtype;
    unsigned int destaddr;
    int len;
    short destport;
};

struct writemsg{
    char msgtype;
    unsigned int pad;
    int len;
    short pad2;
};

struct recvfrommsg{
    short sourceport;
    unsigned int sourceaddr;
    int len;
    short port;
};
