/*
 * This file is part of SOCKMAND.
 * 
 * SOCKMAND is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * SOCKMAND is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with SOCKMAND.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */


struct ipheader;
extern int daemonized;

#define MIGRATEDAWAY -1

struct connectioninfo{ //Resembles a tcp or udp controlblock
    int uuid;
    int sockmandapi_id;
    int protocol;
    short status;
    unsigned short sourceport; //in network format
    unsigned int current_address;
    unsigned int mcap_address;
};

int core_init(int isdaemonized, unsigned int default_mcap);
int core_exit();

void handle_signal(char* signal);
void handle_tunneled_packet(struct ipheader *ippacket, unsigned int src_address);
int handle_ip_packet(struct ipheader *ippacket);
void handle_captured_packet(struct ipheader *ippacket);
int willpiggyback(int appsockid);
int migrate_socket(int uuid, unsigned int newaddr);
void send_socket_state(struct connectioninfo *c, unsigned int address);

