/*
 * This file is part of SOCKMAND.
 * 
 * SOCKMAND is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * SOCKMAND is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with SOCKMAND.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */

#include <sys/socket.h>
#include <netinet/in.h>
#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <unistd.h>

#include "core.h"
#include "tunnel.h"
#include "utils.h"
#include "signal.h"
#include "headers.h"

#define TUNNELPORT 5000

int tunnel_sockfd;

int tunnel_init(){
    tunnel_sockfd = socket(AF_INET,SOCK_DGRAM,0);
   
    struct sockaddr_in servaddr;    
    bzero(&servaddr,sizeof(servaddr));
    servaddr.sin_family = AF_INET;
    servaddr.sin_addr.s_addr = htonl(INADDR_ANY);
    servaddr.sin_port = htons(TUNNELPORT);
    int ret = bind(tunnel_sockfd,(struct sockaddr *)&servaddr,sizeof(servaddr));
    if(ret< 0){
        perror("bind ()");
        exit(-1);        
    }
    fprintf(stderr, "Tunnel setup\n");
    return ret;
}

int tunnel_exit(){
    return close(tunnel_sockfd);
}


int write_tunneled_packet(struct ipheader *ippacket, unsigned int dst_ip){   
    struct sockaddr_in servaddr;
    bzero(&servaddr,sizeof(servaddr));
    servaddr.sin_family = AF_INET;
    
    servaddr.sin_addr.s_addr = dst_ip;
    servaddr.sin_port = htons(TUNNELPORT);
    
    return sendto(tunnel_sockfd,ippacket,ippacket->ip_len,0, (struct sockaddr *)&servaddr,sizeof(servaddr));
}


void read_tunneled_packet( ){
    char buf[1600];
    struct sockaddr_in from;
    socklen_t fromlen = sizeof(from);
    recvfrom( tunnel_sockfd, buf, sizeof(buf), 0, (struct sockaddr*) &from, &fromlen );
    struct ipheader *ip = (struct ipheader *)&buf;
    handle_tunneled_packet(ip, from.sin_addr.s_addr);
}


