/*
 * This file is part of SOCKMAND.
 * 
 * SOCKMAND is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * SOCKMAND is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with SOCKMAND.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */

#define UDPACTIVE 0
#define UDPCLOSED 1

struct ipheader;

struct bufferedpacket;

struct udp_cb{
    int uuid;
    int sockmandapi_id;
    int protocol;
    short status;
    unsigned short sourceport; //in network format
    unsigned int current_address;
    unsigned int mcap_address;
    struct bufferedpacket* bufferedpacketsfirst;
    struct bufferedpacket* bufferedpacketslast;
};


int udp_get_cb_by_uuid(int uuid);
void udp_deliverbufferdpackets(int cb);

void udp_importstate(struct udp_cb *c);
int udpwrite(int cb, const void *buf, int len, unsigned int destaddr, short destport);
void udpread(struct ipheader* ip);
int udpbind(int sockmandapi_id, int uuid, short sourceport, unsigned int mcap_address);
void set_udp_unbound(int cb);

int udp_is_app_present(struct ipheader *ip);
unsigned int udp_get_app_location(struct ipheader *ip);
void* udp_get_connection_info_by_uuid(int uuid);



void* get_udp_cb_pointer(int id);
