/*
 * This file is part of SOCKMAND.
 * 
 * SOCKMAND is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * SOCKMAND is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with SOCKMAND.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */

struct ipheader;
struct tcp;
typedef unsigned short u16;
typedef unsigned long u32;
typedef unsigned char u8;

#define TRUE 1
#define FALSE 0

int is_tcp(struct ipheader* iph);
int is_udp(struct ipheader* iph);
int is_my_address(unsigned int addr);
unsigned int get_my_addr();
char* ip_to_char(unsigned int ip);
int ipchar_to_ipuint(char* ip, unsigned int *ipuint);
char* get_readable_dst(struct ipheader* iph);
char* get_readable_src(struct ipheader* iph);


void setnonblocking(int sock);

unsigned short csum(unsigned short *buf, int nwords);
unsigned short tcp_checksum(struct ipheader* iph, struct tcp* tcph, int size);

long int getmillis();
int max(int a, int b);
int min(int a, int b);

